/******************************************************************************\
*       This code and information is provided "as is" without warranty
*       of any kind, either expressed or implied, including but not
*       limited to the implied warranties of merchantability and/or
*       fitness for a particular purpose.
*
*       Copyright (C) 1995 Microsoft Corporation.  All Rights Reserved.
*
\******************************************************************************/
// Voice Command notifications
class CIVCmdNotifySink : public IVCmdNotifySink {
    private:
    DWORD   m_dwRefCnt;
    HWND    m_hwnd;

    public:
    CIVCmdNotifySink(void);
    ~CIVCmdNotifySink(void);

    // IUnkown members that delegate to m_punkOuter
    // Non-delegating object IUnknown
    STDMETHODIMP         QueryInterface (REFIID, LPVOID FAR *);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    // IVCmdNotifySink members
    STDMETHODIMP CommandRecognize (DWORD, PVCMDNAME, DWORD, DWORD, PVOID, DWORD, PSTR, PSTR);
    STDMETHODIMP CommandOther     (PVCMDNAME, PTSTR);
	STDMETHODIMP CommandStart     (void);
    STDMETHODIMP MenuActivate     (PVCMDNAME, BOOL);
    STDMETHODIMP UtteranceBegin   (void);
    STDMETHODIMP UtteranceEnd     (void);
    STDMETHODIMP VUMeter          (WORD);
    STDMETHODIMP AttribChanged    (DWORD);
	STDMETHODIMP Interference     (DWORD);
};
typedef CIVCmdNotifySink * PCIVCmdNotifySink;

// Voice Message notifications
class CIVTxtNotifySink : public IVTxtNotifySink {
    private:
    DWORD   m_dwRefCnt;
    HWND    m_hwnd;

    public:
    CIVTxtNotifySink();
    ~CIVTxtNotifySink();

    // IUnkown members that delegate to m_punkOuter
    // Non-delegating object IUnknown
    STDMETHODIMP         QueryInterface (REFIID, LPVOID FAR *);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    // IVTxtNotifySink members
    STDMETHODIMP AttribChanged    (DWORD);
    STDMETHODIMP Visual           (WCHAR, char, DWORD, PTTSMOUTH);
    STDMETHODIMP Speak            (PSTR, PSTR, DWORD);
    STDMETHODIMP SpeakingStarted  (void);
    STDMETHODIMP SpeakingDone     (void);
};
typedef CIVTxtNotifySink * PCIVTxtNotifySink;

BOOL BeginOLE();
BOOL EndOLE();

const UINT MAXFILENAME= 256;
const UINT MAXSTRLEN=   256;
const UINT MAXCITYLEN=  100;

const UINT RECOG_GLOBAL= 0;
const UINT RECOG_WINDOW= 1;
const UINT RECOG_OFF=    3;

const UINT DIBSIZE=    128;
const UINT IDM_ACTUAL=  20;
const UINT IDM_STRETCH= 21;

const UINT SRTXT_UTTER= 0;
const UINT SRTXT_CMD=   1;
const UINT SRTXT_RESULT=2;
const UINT SRTXT_TIME=  3;

const UINT WM_USERSPEAK=WM_USER+10;
const UINT ID_WINTITLETIMER=2;


typedef struct
{
	int x,y,xsize,ysize;
} PosSize_t;

typedef struct
{
	char  szStrTitle[20];
	char  szStrOut[80];
	POINT pos;
	RECT  rBox;
} SRTextOut;

typedef struct
{
	long lTmBias;
	char szCity[MAXCITYLEN];
} CityList_t;

extern char   *szWinTitle;
extern HWND   ghWndMain;
extern HANDLE hinst;
extern BOOL   bWidthFlag;
extern POINT  scrnsize;
extern RECT   rClient;
extern POINT  TextPos;
extern int    nCmds;
extern TEXTMETRIC TxtInfo;
extern HPEN blkpen, whtpen, ltpen, dkpen;
extern int BitsPerPixel;
extern POINT BorderSize;
extern BOOL  bVMeterFlag;
extern TIME_ZONE_INFORMATION TimeZoneInfo;
extern UINT WM_REG_SPEECHSTARTED;
extern UINT WM_REG_SPEECHENDED;



LONG CALLBACK MainWndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam);
HRESULT InitState ();
HRESULT SpeakString( char *szSpeakStr );
HRESULT ActivateSR( int Flag );
void ActivateSRdialog();
void PaintVMeter( WORD wLevel );
void ToggleView( HWND hwnd );
BOOL BeginOLE();
BOOL EndOLE();