// WebVoxDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Shdocvw.H"
#include "WebVox.h"
#include "WebVoxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWebVoxDlg dialog

CWebVoxDlg::CWebVoxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWebVoxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWebVoxDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWebVoxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWebVoxDlg)
	DDX_Control(pDX, IDC_URL, url_ctrl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWebVoxDlg, CDialog)
	//{{AFX_MSG_MAP(CWebVoxDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_NOTIFYICON, OnNotifyIcon)
END_MESSAGE_MAP()

// MyTaskBarAddIcon - adds an icon to the taskbar status area. 
// Returns TRUE if successful or FALSE otherwise. 
// hwnd - handle of the window to receive callback messages 
// uID - identifier of the icon 
// hicon - handle of the icon to add 
// lpszTip - ToolTip text 
BOOL AddIconToTaskBar(HWND hwnd, UINT uID, HICON hicon, LPSTR lpszTip) 
{ 
    BOOL res; 
    NOTIFYICONDATA tnid; 
 
    tnid.cbSize = sizeof(NOTIFYICONDATA); 
    tnid.hWnd = hwnd; 
    tnid.uID = uID; 
    tnid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP; 
    tnid.uCallbackMessage = WM_NOTIFYICON; 
    tnid.hIcon = hicon; 
    if (lpszTip) 
        lstrcpyn(tnid.szTip, lpszTip, sizeof(tnid.szTip)); 
    else 
        tnid.szTip[0] = '\0'; 
 
    res = Shell_NotifyIcon(NIM_ADD, &tnid); 
 
    if (hicon) 
        DestroyIcon(hicon); 
 
    return res; 
} 

// MyTaskBarDeleteIcon - deletes an icon from the taskbar 
//     status area. 
// Returns TRUE if successful or FALSE otherwise. 
// hwnd - handle of the window that added the icon 
// uID - identifier of the icon to delete 
BOOL DeleteIconFromTaskBar(HWND hwnd, UINT uID) 
{ 
    BOOL res; 
    NOTIFYICONDATA tnid; 
 
    tnid.cbSize = sizeof(NOTIFYICONDATA); 
    tnid.hWnd = hwnd; 
    tnid.uID = uID; 
         
    res = Shell_NotifyIcon(NIM_DELETE, &tnid); 
    return res; 
}
/////////////////////////////////////////////////////////////////////////////
// CWebVoxDlg message handlers

BOOL CWebVoxDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	HICON task_icon = AfxGetApp()->LoadIcon(IDI_TASK);
	AddIconToTaskBar(GetSafeHwnd(),IDI_TASK,task_icon,"WebVox");


	unloadProgram = FALSE;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWebVoxDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}

	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWebVoxDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	static listen_animation_loop;

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC memdc;

		memdc.CreateCompatibleDC(&dc);

		CBitmap listen_bmp;

		if (listen_animation_loop == 0)
			listen_bmp.LoadBitmap(IDB_LISTEN1);
		else if (listen_animation_loop == 1)
			listen_bmp.LoadBitmap(IDB_LISTEN2);
		else if (listen_animation_loop == 2)
			listen_bmp.LoadBitmap(IDB_LISTEN3);
		else if (listen_animation_loop == 3)
			listen_bmp.LoadBitmap(IDB_LISTEN2);


		listen_animation_loop += 1;

		if (listen_animation_loop > 3)
			listen_animation_loop = 0;

		memdc.SelectObject(listen_bmp);

		dc.BitBlt( 10, 0, 20, 20, &memdc, 0, 0, SRCCOPY );
		listen_bmp.DeleteObject();


		memdc.DeleteDC();

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWebVoxDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWebVoxDlg::OnOK() 
{
	OpenPage();
}

void CWebVoxDlg::OpenPage()
{
	CString url;
	// TODO: Add extra validation here
	url_ctrl.GetWindowText(url);
	IWebBrowserApp * m_pIE=((CWebVoxApp *)AfxGetApp())->m_pIE;
	COleVariant noArg;	//  declare a VT_EMPTY variant.
	m_pIE->Navigate(url, &noArg, &noArg, &noArg, &noArg);
	m_pIE->SetVisible(TRUE);

}

void CWebVoxDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	if (unloadProgram==TRUE)
		CDialog::OnClose();
	else
		ShowWindow(SW_HIDE);
}

// OnNotifyIcon - processes callback messages for taskbar icons 
// wParam - first message parameter of the callback message 
// lParam - second message parameter of the callback message 
void CWebVoxDlg::OnNotifyIcon(WPARAM wParam, LPARAM lParam) 
{ 
    UINT uMouseMsg; 
 
    uMouseMsg = (UINT) lParam; 
 
    if (uMouseMsg == WM_LBUTTONDOWN) 
	{	
     ShowWindow(SW_SHOW);             
	} 
      
	return;  
} 
 

BOOL CWebVoxDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (wParam == ID_OPTIONS_REMOVEFROMTASKBAR)
	{
		DeleteIconFromTaskBar(GetSafeHwnd(),IDI_TASK);
		return TRUE;
	}
	if (wParam == ID_OPTIONS_QUIT)
	{
		QuitApp();
		return TRUE;
	}
	else
		return CDialog::OnCommand(wParam, lParam);
}

void CWebVoxDlg::QuitApp()
{
	DeleteIconFromTaskBar(GetSafeHwnd(),IDI_TASK);
	unloadProgram = TRUE;
	EndDialog(0);	
}
